"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var test_utils_1 = require("./test-utils");
var book_1 = require("./sample/entities/book");
var genre_1 = require("./sample/entities/genre");
var author_1 = require("./sample/entities/author");
var FakeEntity = /** @class */ (function () {
    function FakeEntity() {
    }
    return FakeEntity;
}());
describe('entity-factory', function () {
    var orm;
    var em;
    var container;
    beforeAll(function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, test_utils_1.getConnectionOrm()];
                case 1:
                    orm = _a.sent();
                    em = orm.em;
                    return [4 /*yield*/, test_utils_1.getContainer(orm.em)];
                case 2:
                    container = _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    afterAll(function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, orm.isConnected()];
                case 1:
                    if (!_a.sent()) return [3 /*break*/, 3];
                    return [4 /*yield*/, orm.close()];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3: return [2 /*return*/];
            }
        });
    }); });
    it('can provide for factories with init()', function () { return __awaiter(void 0, void 0, void 0, function () {
        var bookFactory, genreFactory, authorFactory, famousAuthorFactory;
        return __generator(this, function (_a) {
            bookFactory = container.getFactory(book_1.Book);
            genreFactory = container.getFactory(genre_1.Genre);
            authorFactory = container.getFactory(author_1.Author);
            famousAuthorFactory = container.getFactory(author_1.Author, 'famous');
            expect(bookFactory).toBeDefined();
            expect(genreFactory).toBeDefined();
            expect(authorFactory).toBeDefined();
            expect(famousAuthorFactory).toBeDefined();
            // @ts-ignore TS2345 (Ignore private method)
            expect(bookFactory.faker).toBeDefined();
            // @ts-ignore TS2345 (Ignore private method)
            expect(genreFactory.faker).toBeDefined();
            return [2 /*return*/];
        });
    }); });
    it('throws error when entity does not exist', function () { return __awaiter(void 0, void 0, void 0, function () {
        var thrownError;
        return __generator(this, function (_a) {
            thrownError = null;
            try {
                container.getFactory(FakeEntity);
            }
            catch (e) {
                thrownError = e;
            }
            expect(thrownError).toBeDefined();
            expect(thrownError.message.indexOf('Unable to retrieve factory instance for key: FakeEntity')).toBeGreaterThanOrEqual(0);
            return [2 /*return*/];
        });
    }); });
});
