"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EntityFactory = void 0;
var Faker = __importStar(require("faker"));
/**
 * @abstract
 * @class EntityFactory
 * @summary
 * The Abstract EntityFactory is the class that all registered
 * factories must extend to produce entities.
 *
 * @typeparam E: The Entity that the factory generates
 */
var EntityFactory = /** @class */ (function () {
    /**
     * @constructor
     * @property em: MikroORM Entity Manager
     * @property container: The factory container
     * acts parent reference for using other factories within a factory
     * @property faker: Faker library for having stub data
     */
    function EntityFactory(em, container, faker) {
        if (faker === void 0) { faker = Faker; }
        this.em = em;
        this.container = container;
        this.faker = faker;
    }
    /**
     * @public
     * @summary
     * Create and insert many entities into the database
     *
     * @param count: The number of entities to save (default is 1)
     * @param overrides: The object to override with - passed down into make
     * @returns An array of saved entities
     */
    EntityFactory.prototype.saveMany = function (count, overrides) {
        var e_1, _a;
        if (count === void 0) { count = 1; }
        return __awaiter(this, void 0, void 0, function () {
            var entityArray, _b, _c, index, entity, entityOverrides_1, e_1_1;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        entityArray = [];
                        _d.label = 1;
                    case 1:
                        _d.trys.push([1, 7, 8, 13]);
                        _b = __asyncValues(__spread(Array(count).keys()));
                        _d.label = 2;
                    case 2: return [4 /*yield*/, _b.next()];
                    case 3:
                        if (!(_c = _d.sent(), !_c.done)) return [3 /*break*/, 6];
                        index = _c.value;
                        return [4 /*yield*/, this.make(overrides)];
                    case 4:
                        entity = _d.sent();
                        /**
                         * Manually override each key of E.
                         * Loop through key of entity, if a value was passed into the override
                         * then set it on the entity. This assured we don't save a keyof O onto
                         * our entity of type E
                         */
                        if (overrides) {
                            entityOverrides_1 = __assign({}, overrides);
                            Object.keys(entity).forEach(function (key) {
                                /** Grab the value at override[key] which is of type E[key] */
                                var overrideValue = entityOverrides_1[key];
                                /** If the override is not undefined, we can set it on the entity */
                                if (typeof overrideValue !== 'undefined') {
                                    entity[key] = overrideValue;
                                }
                            });
                        }
                        entityArray.push(entity);
                        _d.label = 5;
                    case 5: return [3 /*break*/, 2];
                    case 6: return [3 /*break*/, 13];
                    case 7:
                        e_1_1 = _d.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 13];
                    case 8:
                        _d.trys.push([8, , 11, 12]);
                        if (!(_c && !_c.done && (_a = _b.return))) return [3 /*break*/, 10];
                        return [4 /*yield*/, _a.call(_b)];
                    case 9:
                        _d.sent();
                        _d.label = 10;
                    case 10: return [3 /*break*/, 12];
                    case 11:
                        if (e_1) throw e_1.error;
                        return [7 /*endfinally*/];
                    case 12: return [7 /*endfinally*/];
                    case 13: 
                    /** Save all of the entities */
                    return [4 /*yield*/, this.em.persistAndFlush(entityArray)];
                    case 14:
                        /** Save all of the entities */
                        _d.sent();
                        return [2 /*return*/, entityArray];
                }
            });
        });
    };
    /**
     * @public
     * @summary
     * Create and insert one entity into the database
     *
     * @param overrides: The object to override with - passed down into make()
     * @returns An entity
     */
    EntityFactory.prototype.saveOne = function (overrides) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, entity;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.saveMany(1, overrides)];
                    case 1:
                        _a = __read.apply(void 0, [_b.sent(), 1]), entity = _a[0];
                        return [2 /*return*/, entity];
                }
            });
        });
    };
    return EntityFactory;
}());
exports.EntityFactory = EntityFactory;
